var sellerInfo = {};
var buyInfo = [];
var clientBase;
var familyBase;
//收货地址
var address = "";
//联系电话
var phone = "";

//配送时间列表
var timeList = [];

//已选择的送达时间 提交参数
var selectTime = "";

//已选择的送达时间 用于界面显示
var selectTimeText = "";

var params = {};

//实际付款金额
var payPrice = 0.00;

//订单总额
var totalPrice = 0.00;

var displayTotal = 0.00;

function onLoad() {
	try {
		sellerInfo = ClientUtil.stringToJson(FamilyCache.GetCache("family.waimai.sellerInfo"));
		buyInfo = ClientUtil.stringToJson(FamilyCache.GetCache("family.waimai.order"));

		clientBase = FamilyDB.GetClientBase();

		$("list-service").sndcaption = "本订单由" + (sellerInfo.sellerName || "") + "为您提供配送服务";
		$("list-service").rcaption = "￥" + (sellerInfo.serivcePrice || 0);

		var serivcePrice = parseFloat(sellerInfo.serivcePrice);
		var distinctPrice = parseFloat(sellerInfo.distinctPrice);
		//订单总额
		var totalCount = 0;
		var goodsId = "";
		for (var i = 0; i < buyInfo.length; i++) {
			var buy = buyInfo[i];
			totalPrice += parseFloat(buy.goodsPrice) * parseInt(buy.buyNumber);
			totalCount += parseInt(buy.buyNumber);
			goodsId += buy.goodsId + ",";
		}
		totalPrice = totalPrice.toFixed(2);

		$("list-orderInfo").rcaption = "￥" + totalPrice + "/" + totalCount + "份";
		$("buyInfo").clear().provide(buyInfo).show();

		displayTotal = (parseFloat(totalPrice) + parseFloat(serivcePrice)).toFixed(2);
		$("totalPrice").html("￥" + displayTotal);

		//实际付款金额
		payPrice = parseFloat(totalPrice);
		if (totalPrice < distinctPrice) {
			payPrice = payPrice + serivcePrice;
		}
		payPrice = payPrice.toFixed(2);
		$("payPrice").html("￥" + payPrice);

		if (payPrice >= (totalPrice + serivcePrice)) {
			$("totalPrice").hide();
		}

		if (totalPrice >= distinctPrice) {
			$("list-distinct").rcaption = "-￥" + serivcePrice;
		}

		var datas = "method=Online_GetWaimaiParam";
		datas += "&sellerId=" + sellerInfo.sellerId;
		datas += "&clientId=" + ( clientBase ? clientBase.id : FamilyCache.EmptyId);
		datas += "&goodsId=" + goodsId;
		Family.DoRequest({
			url : FamilyCache.Onlineurl(),
			data : datas,
			onComplete : function() {
				$("loading").html("正在加载");
			},
			success : function(rs) {
				try {
					$("loading").html("");
					var data = Family.ToJSON(rs.responseText);

					if (data && data.response.code == 200) {
						params = data;

						address = (data.body.address || (data.body.defaultAddress || "添加收货地址"));
						phone = data.body.phone || data.body.defaultPhone;
						$("list-address").caption = address;

						timeList = data.body.timeList;
						$("timelist").clear().provide(timeList);

						$("body").show();
						$("footer").show();
					} else {
						$("loading").html("<a href='onLoad()'>加载失败，点击重试</a>");
					}
				} catch(e) {
					$("loading").html("<a href='onLoad()'>加载失败，点击重试</a>");
				}
			},
			fail : function() {
				$("loading").html("<a href='onLoad()'>加载失败，点击重试</a>");
			}
		});

	} catch(e) {
	}
}

/**
 *手机返回键处理
 */
function goBack() {
	try {
		var fixtime = $("fixtime");
		if (fixtime.style.display == "block") {
			fixtime.hide();
			return;
		}
		close();
	} catch(e) {

	}
}

/**
 *显示时间列表
 */
function showTimeList() {
	try {
		window.beignPreferenceChange();
		var timeDom;
		var imgDom;
		for (var i = 0; i < timeList.length; i++) {
			var time = timeList[i];
			timeDom = $("time" + time.value);
			imgDom = $("img" + time.value);
			if (timeDom) {
				timeDom.className = "fixtime";
			}
			if (imgDom) {
				imgDom.hide();
			}
		}
		timeDom = $("time" + selectTime);
		imgDom = $("img" + selectTime);
		if (timeDom) {
			timeDom.className = "fixtimecur";
		}
		if (imgDom) {
			imgDom.show();
		}
		$("fixtime").show();
		window.endPreferenceChange();
	} catch(e) {

	}
}

function selectedTime(value, text) {
	try {
		selectTime = value;
		selectTimeText = text;
		$("list-time").rcaption = text;
		$("fixtime").hide();
	} catch(e) {

	}
}

function showAddress() {
	try {
		if (!params.body.address) {
			open("res:page/areadiscount/waimai.address.edit.uixml?callbackFn=refreshAddress&callbackWindowId=waimai-order");
			return;
		}
		open("res:page/areadiscount/waimai.address.uixml?callbackFn=refreshAddress&callbackWindowId=waimai-order");
	} catch(e) {

	}
}

/**
 *刷新收货地址
 */
function refreshAddress(name, _phone, _address) {
	phone = _phone;
	address = name + " " + _phone + " " + _address;
	params.body.address = address;
	$("list-address").caption = address;
}

/**
 *下单
 */
function buy() {
	try {
		if (!address) {
			Family.Toast.Show("请填写收货地址");
			return;
		}
		if (!selectTime) {
			Family.Toast.Show("请选择送达时间");
			return;
		}
		var datas = "phone=" + phone;
		datas += "&address=" + address;
		datas += "&selectTime=" + selectTime;
		datas += "&selectTimeText=" + selectTimeText;
		datas += "&payPrice=" + payPrice;
		datas += "&displayTotal=" + displayTotal;
		datas += "&storeId=" + (window.getParameter("storeId") || FamilyCache.EmptyId);
		open("res:page/areadiscount/waimai.order.sure.uixml?" + datas);
	} catch(e) {

	}
}

