var clientBase;
function load() {
	try {
		clientBase = FamilyDB.GetClientBase();
		if (FamilyDB.CheckPattern()) {
			return;
		}
		var bl = DeviceUtil.isSupportBluetooth();
		if (bl) {
			var os = DeviceUtil.getOs();
			if (os == "ios") {
				$("div_ios").show();
				$("div_android").hide();
			} else {
				$("div_ios").hide();
				$("div_android").show();
			}
			openDoorInitMac();
		}
	} catch(e) {
	}
}

//------------------------------蓝牙门禁------------------------------//
var bluetime;
/**
 * 蓝牙门禁-获得门禁初始化的mac地址,并且执行初始化
 */
function openDoorInitMac() {
	var dooList = FamilyDB.GetDoors();
	if (dooList) {
		$("body").clear().provide(dooList).show();
		//初始化蓝牙门禁
		for (var i = 0; i < dooList.length; i++) {
			if (parseInt(dooList[i].door_type) == 3) {//为蓝牙门禁
				var bluetooch = dooList[i].door_BLmac,
				    mac = "";
				if (bluetooch.indexOf(",") === -1) {//没有逗号
					mac = bluetooch;
				} else {
					mac = bluetooch.split(",")[0];
				}
				FamilyCache.SetCache("cache_" + mac, "");
			}
		}
	}
}

function Bluetoothinit() {
	try {
		var native;
		var os = DeviceUtil.getOs();
		if (os == "ios") {
			native = document.getElementById("door_ios");
		} else {
			native = document.getElementById("door_android");
		}
		if (native) {
			native.call("init", "", "");
		}
	} catch(e) {
		Family.ProcessBar.Hide();
	}
}

/**
 * 蓝牙门禁-设置密码
 */
function BluetoothSetPwd(blue_mac, blue_pwd) {
	clearTimeout(bluetime);
	try {
		var rs,
		    native;
		var os = DeviceUtil.getOs();
		if (os == "ios") {
			native = document.getElementById("door_ios");
		} else {
			native = document.getElementById("door_android");
		}
		native.call("setDevPassword", blue_mac, blue_pwd);
	} catch(e) {
	}
}

/**
 * 蓝牙门禁-开门
 */
function BluetoothOpen(blue_mac, blue_pwd, name) {
	try {
		if (!blue_mac) {
			Family.Toast.Show("MAC地址不能为空,请联系管理员配置");
			return;
		}
		var native;
		var os = DeviceUtil.getOs();
		if (os == "ios") {
			native = document.getElementById("door_ios");
		} else {
			native = document.getElementById("door_android");
		}
		var rs = native.call("openDoor", blue_mac.toLowerCase(), "50", blue_pwd.toLowerCase());
		if (rs) {
			if (rs.indexOf("成功") > -1 || rs == "0") {
				FamilyCache.SetCache("cache_" + blue_mac, blue_mac);
				WriteLod(2, name);
				Family.Toast.Show("开门成功");
			} else if (rs == "5") {
				//开门失败清楚开门缓存，下次开门会初始化
				FamilyCache.SetCache("cache_" + blue_mac, "");
				Family.Toast.Show("您的蓝牙未开启,请打开蓝牙后重新打开页面");
			} else {
				//开门失败清楚开门缓存，下次开门会初始化
				FamilyCache.SetCache("cache_" + blue_mac, "");
				Family.Toast.Show("开门失败,请重试!错误码:" + ClientUtil.jsonToString(rs));
			}
		} else {
			FamilyCache.SetCache("cache_" + blue_mac, "");
			Family.Toast.Show("开门失败,请重试!");
		}
	} catch(e) {
	}
}

//------------------------------蓝牙门禁代码结束------------------------------//
/**
 * 智能开门日志   @type 日志添加类别：2-蓝牙，1-wifi
 */
function WriteLod(type, name) {
	try {
		var ESN = DeviceUtil.getEsn();
		var clientId = ( clientBase ? clientBase.id : FamilyCache.EmptyId);
		var url = FamilyDB.GetPostAddress();
		var datas = "method=Property_DoorOpenLog&eid=" + clientId + "&code=" + name + "&primarykey=" + ESN + "&type=" + type;
		Family.DoRequest({
			url : url,
			data : datas,
			isBlock : false,
			success : function(rs) {
			},
			fail : function(rs) {
			}
		});
	} catch(e) {
	}
}

function refreshDoors() {
	try {
		var ownerIdList = "";
		var isEmployee = 0;
		var familyBase = FamilyDB.GetFamilyBase();
		var clientBase = FamilyDB.GetClientBase();
		var clientId = ( clientBase ? clientBase.id : FamilyCache.EmptyId);
		var houseData = FamilyDB.GetOwnerHouse(clientId);
		if (houseData && houseData.length > 0) {
			///ownerId
			for (var i = 0; i < houseData.length; i++) {
				var house = houseData[i];
				ownerIdList += house.ownerId + ",";
				if (house.objectName == "内部员工") {
					isEmployee = 1;
				}
			}
			if (isEmployee == 1) {
				for (var i = 0; i < houseData.length; i++) {
					var house = houseData[i];
					if (house.areaId.toLowerCase() == familyBase.areaId.toLowerCase()) {
						ownerIdList = house.esareaId;
						break;
					}
				}
			}
		}
		var datas = "method=Property_GetDoors";
		datas += "&ownerIdList=" + ownerIdList;
		datas += "&isEmployee=" + isEmployee;
		Family.DoRequest({
			url : FamilyDB.GetPostAddress(),
			data : datas,
			isBlock : true,
			success : function(rs) {
				rs = Family.ToJSON(rs.responseText);
				FamilyDB.SetDoors(rs);
				$("body").clear().provide(rs).show();
				Family.Toast.Show("已刷新");
			},
			fail : function() {
				Family.Toast.Show("刷新钥匙失败");
			}
		});
	} catch(e) {
	}
}

function clearDoors() {
	try {
		confirm("确定清除钥匙？", function() {
			FamilyDB.SetDoors([]);
			$("body").clear().provide([]).show();
		});
	} catch(e) {

	}
}

function openDoor(ip, mac, door, doortype, bluetooth) {
	try {
		var params = "ip=" + ip + "&mac=" + mac + "&door=" + door + "&doortype=" + doortype + "&bluetooth=" + bluetooth + "&parent=doorslist";
		if (parseInt(doortype) == 3) {//立方门禁
			var bl = DeviceUtil.isSupportBluetooth();
			if (!bl) {
				Family.Toast.Show("当前设备不支持蓝牙");
				return;
			}
			var blue_mac;
			if (bluetooth.indexOf(",") === -1) {
				blue_mac = bluetooth;
				blue_pwd = "64AB8921DE67AC34";
			} else {
				blue_mac = bluetooth.split(",")[0];
				blue_pwd = bluetooth.split(",")[1];
			}
			var cache_bl_mac = FamilyCache.GetCache("cache_" + blue_mac);
			if (!cache_bl_mac && cache_bl_mac != blue_mac) {
				Bluetoothinit();
				Family.ProcessBar.Show("正在连接");
				setTimeout("getOpenDoor('" + params + "')", 5000);
			} else {
				getOpenDoor(params);
			}
		} else {
			getOpenDoor(params);
		}
	} catch(e) {
	}
}

function getOpenDoor(params) {
	Family.ProcessBar.Hide();
	open("res:page/doors.open.uixml?" + params);
}