var _mapIndex_ = 0;

var _cacheMap_ = {};

var _ajax_success_ = function(ajax) {
	try {
		var index = ajax.getStringData("_mapIndex_");
		_cacheMap_[index].success && _cacheMap_[index].success(ajax);
	} catch(e) {

	}

};
var _ajax_fail_ = function(ajax) {
	try {
		var index = ajax.getStringData("_mapIndex_");
		_cacheMap_[index].fail && _cacheMap_[index].fail(ajax);
	} catch(e) {

	}
};

/**
 *通用类 可在uixml、xhtml、html5中运行
 */
var Family = (function() {
	/**
	 *进度条提示
	 */
	var _processBar = {
		process : null,
		Show : function(msg, isBlock) {
			msg = msg || "";
			_processBar.process = _processBar.process ? _processBar.process : (new ProgressBar());
			_processBar.process.setMessage(msg);
			_processBar.process.show(isBlock || false);
		},
		Hide : function() {
			_processBar.process && _processBar.process.cancel();
		}
	};

	/***
	 *操作提示
	 */
	var _toast = {
		Show : function(text, duration, style) {
			duration = duration || 2000;
			var toast = new Toast();
			toast.setText(text || "");
			toast.setDuration(duration);
			style && toast.setStyle(style);
			toast.show();
		},
		Error : function(text, duration, style) {
			_toast.Show(text, duration, (style || "background-color:#eb4f38;color:white;border-color:#eb4f38;"));
		}
	};

	/**
	 *JS生成Guid
	 */
	var _newId = function() {
		var S4 = function() {
			return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
		};
		return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
	};
	/**
	 * 获取当前网络连接状态
	 * 返回true，表示有可用网络连接
	 * 返回false，表示没有可用网络连接
	 */
	var _netConnectState = function() {
		return NetworkUtil.getConnectState();
	};
	/**
	 *普通请求
	 * @param {Object} option
	 * 请求参数 JSON格式
	 * {url:"",data:"",success:function(){},fail:function(){},isBlock:true,timeout:"",onComplete:function(){}}
	 */
	var _doRequest = function(option) {

		if (!_netConnectState()) {
			_toast.Error("无网络连接,请检查您的网络设置");
			//return;
		}
		option.onComplete && option.onComplete();
		var request = {
			url : option.url,
			method : (option.method || "POST"),
			data : encodeURI(option.data),
			timeout : (option.timeOut || 1 * 30 ) * 1000,
			successFunction : "_ajax_success_",
			failFunction : "_ajax_fail_",
			isBlock : (option.isBlock || false)
		};
		var direct = new DirectAjax(request);
		_mapIndex_++;
		direct.setStringData("_mapIndex_", _mapIndex_);
		_cacheMap_[_mapIndex_] = option;

		direct.send();

	};
	/**
	 *带附件上传的请求
	 * @param {Object} option
	 * 请求参数 JSON格式
	 * {url:"",data:"",success:function(){},fail:function(){},isBlock:true,timeout:"",onComplete:function(){}}
	 */
	var _doFormRequest = function(option) {
		if (!_netConnectState()) {
			_toast.Error("无网络连接,请检查您的网络设置");
			//return;
		}
		option.onComplete && option.onComplete();
		var request = {
			url : option.url,
			data : option.data,
			method : (option.method || "POST"),
			successFunction : "_ajax_success_",
			failFunction : "_ajax_fail_",
			reqCharset : "utf-8",
			isBlock : (option.isBlock || false),
			timeout : (option.timeOut || 1 * 30) * 1000
		};
		var ajax = new DirectFormSubmit(request);
		_mapIndex_++;
		ajax.setStringData("_mapIndex_", _mapIndex_);
		_cacheMap_[_mapIndex_] = option;
		ajax.send();
	};
	/**
	 *二维码解析
	 */
	var _decode = function(fn) {
		if (!fn) {
			return;
		}
		var decode = new Decode();
		var callback = function() {
			if (!decode.isSuccess()) {
				return;
			}
			fn && fn(decode.result);
		};
		decode.onCallback = callback;
		decode.startDecode();

	};
	/**
	 *调用系统相册
	 * @param {Object} option 参数为JSON格式
	 * {pwidth:0,maxnums:5,callback:function(){}}
	 */
	var _imageChoice = function(option) {
		var imageChoice = new ImageChoice();

		var callback = function(selectPaths) {
			option.callback && option.callback(selectPaths, imageChoice);
		};
		if (option.pwidth) {
			imageChoice.pwidth = option.pwidth;
		}

		if (option.maxnums) {
			imageChoice.nums = option.maxnums;
		}
		imageChoice.onCallback = callback;
		imageChoice.start();
	};
	/**
	 * 拍照
	 * @param {Object} option
	 */
	var _camera = function(option) {
		var camerawindow = new CameraWindow();
		var callback = function() {
			if (camerawindow.isSuccess()) {
				option.callback && option.callback(camerawindow.value);
			}
		};
		if (option.pwidth) {
			camerawindow.pwidth = option.pwidth;
		}
		if (option.path) {
			camerawindow.path = option.path;
		}
		if (option.iscrop) {
			camerawindow.iscrop = option.iscrop;
		}
		camerawindow.onCallback = callback;
		camerawindow.startCamera();
	};
	var _selectCameraPhoto = function(option) {

		var callback = function(path) {
			option.callback && option.callback(path);
		};

		NativeUtil.selectCameraPhoto(callback, option.pwidth, (option.iscrop || false));
	};
	/**
	 * 分享至新浪
	 * @param {Object} option
	 */
	var _shareSina = function(option) {
		var sendcallback = function(weiboinfo) {
			if (weiboinfo.result == 0) {
				_toast.Show("分享成功");
			} else {
				_toast.Show("分享失败,稍等片刻在重试");
			}
		};
		var weibo = new WeiboInfo();
		weibo.type = "sina";
		if (option.content) {
			weibo.content = option.content;
		}
		if (option.file) {
			weibo.file = option.file;
		}
		if (option.longitude) {
			weibo.longitude = option.longitude;
		}
		if (option.latitude) {
			weibo.latitude = option.latitude;
		}
		weibo.sendcallback = sendcallback;
		weibo.send();
	};
	/***
	 *分享至腾讯微博
	 * @param {Object} option
	 */
	var _shareTencent = function(option) {

		var sendcallback = function(weiboinfo) {
			if (weiboinfo.result == 0) {
				_toast.Show("分享成功");
			} else {
				_toast.Show("分享失败,稍等片刻在重试");
			}
		};
		var weibo = new WeiboInfo();
		weibo.type = "tencent";
		if (option.content) {
			weibo.content = option.content;
		}
		if (option.file) {
			weibo.file = option.file;
		}
		if (option.longitude) {
			weibo.longitude = option.longitude;
		}
		if (option.latitude) {
			weibo.latitude = option.latitude;
		}
		weibo.sendcallback = sendcallback;
		weibo.send();
	};
	/**
	 *解除微博绑定
	 */
	var _clearWeiboBind = function() {
		var weibo = new WeiboInfo();
		weibo.clearbind();
	};
	/**
	 * json转换
	 * @param {Object} data
	 */
	var _toJSON = function(data) {
		return eval("(" + data + ")");
	};

	var _webViewCallBack = function(webviewId, windowId, functionName, datas) {
		//var webview = document.getElementById(webviewId);
		var dlg = PageUtil.getWindowById(windowId);
		if (dlg) {
			dlg.document.getElementById(webviewId).executeScript(functionName + "(" + datas + ")");
		}
	};

	/**
	 *创建浏览器
	 * @param {Object} options
	 */
	var _createWebView = function(options) {
		var _default = {
			container : "", //父容器
			id : "", //浏览器id
			url : "", //载入的url
			showprogress : true, //是否显示进度条
			transparent : false,
			onfailload : "",
			className : "",
			zoom : false,
			style : "",
			backmonitor : false, //浏览器加载后，点击手机物理back键是触发webview 的backmonitor事件 还是采用默认方式关闭页面
			pushmonitor : false, //接收到push消息后，是否触发webview自定义onpush事件
			onreceivedtitle : "", //webview页面加载url，若标题更新则触发回调函数。该回调函数具有json格式入参，定义如下：title：当前页面标题，字符串类型
			showerrorpage : "", //网络url加载失败时是否显示错误提示界面  5.11+支持
			showerrorpage : false//网络url加载失败时是否显示错误提示界面
		};
		for (var p in options) {
			_default[p] = options[p];
		}
		
		//_default.url += (_default.url.indexOf("?") == "-1" ? "?" : "&") + "r=" + Family.NewId();
		var webview = "<webview id=\"" + _default.id + "\" ";
		webview += "url=\"" + _default.url.replace(new RegExp("&", "g"), "&amp;") + "\" ";
		webview += "class=\"" + _default.className + "\" ";
		webview += "showprogress=\"" + _default.showprogress + "\" ";
		webview += "transparent=\"" + _default.transparent + "\" ";
		webview += "onfailload=\"" + (_default.onfailload || "_onWebViewFailLoad") + "\" ";
		webview += "className=\"" + _default.className + "\" ";
		webview += "zoom=\"" + _default.zoom + "\" ";
		webview += "style=\"" + _default.style + "\" ";
		webview += "backmonitor=\"" + _default.backmonitor + "\" ";
		webview += "pushmonitor=\"" + _default.pushmonitor + "\" ";
		webview += "onreceivedtitle=\"" + (_default.onreceivedtitle || "_onWebViewReceivedTitle") + "\" ";
		webview += "></webview>";
		document.getElementById(_default.container).innerHTML = webview;
		try {
			var dom = document.getElementById(_default.id);
			dom && dom.clearCache();
			_cacheWebViewId = _default.id;
		} catch(e) {

		}
	};

	return {
		DoRequest : _doRequest, //普通请求
		DoFormRequest : _doFormRequest, //带附件上传的请求
		ProcessBar : _processBar, //进度条
		Toast : _toast, //提示信息
		NewId : _newId, //JS生成Guid
		NetConnectState : _netConnectState, //网络连接状态
		Decode : _decode, //二维码解析
		ImageChoice : _imageChoice, //调用相册
		Camera : _camera, //拍照
		SelectCameraPhoto : _selectCameraPhoto, //调用系统相册
		ShareSina : _shareSina, //分享至新浪
		ShareTencent : _shareTencent, //分享至腾讯微博
		ClearWeiboBind : _clearWeiboBind, //解除微博绑定
		ToJSON : _toJSON, //json转换
		WebViewCallBack : _webViewCallBack,
		CreateWebView : _createWebView//创建浏览器
	};
})();

var _cacheWebViewId = "";
function _onWebViewReceivedTitle() {
	try {
		//setTimeout("Family.ProcessBar.Hide();", 3000);
		//var dom = document.getElementById(_cacheWebViewId);
	} catch(e) {

	}
}

function _onWebViewFailLoad() {
	try {
		Family.ProcessBar.Hide();
		var dom = document.getElementById(_cacheWebViewId);
		dom && dom.loadUrl("res:page/webviewError.html");
	} catch(e) {

	}
}

