/**
 *依赖exmobijs中的base.js
 */
var FamilyUtils = (function() {
	/**
	 * 格式化表单数据
	 * @param {Object} formId 表单id
	 */
	var _escapeFormData = function(formId) {
		var data = document.getElementById(formId).getSubmitData();
		var formStr = "[";
		for ( i = 0; i < data.length; i++) {
			var d = data[i];
			formStr += "{";
			formStr += "\"type\":\"" + d.type + "\",";
			formStr += "\"name\":\"" + d.name + "\",";
			formStr += "\"value\":\"" + EncryptionUtil.base64Decode(d.value) + "\"";
			formStr += "},";
		}
		formStr += "]";
		return formStr.toJSON();
	};

	var _loadingfail = function(callback, msg) {
		msg = msg || "加载失败，点击<a style='color:#56abe4' href='" + callback + "();'>重试</a>";
		return "<div style='height:100%;text-align:center;text-valign:middle'>" + msg + "</div>";
	};

	var _loadingH5 = {
		dom : "#loadingH5",
		Show : function(container, msg, style) {
			$(_loadingH5.dom).remove();
			style = style || "text-align:center;background-color:transparent;line-height:50px;min-height:50px;";
			var div = "<div id='loadingH5' style='" + style + "'>" + msg + "</div>";
			$(div).appendTo($(container));
		},
		Hide : function() {
			$(_loadingH5.dom).remove();
		}
	};

	var _loadingImg = function(src) {
		return "<img style='margin-right:5px;' class='img' src='" + (src || "../../image/icon/loading.gif") + "' />";
	};

	var _registerTip = function(callback) {
		var btn1 = "height:40px;text-align:center;line-height:40px;background-color:#60BFF3;color:white;border-radius:4px;";
		var btn2 = "height:40px;text-align:center;line-height:40px;color:white;border-radius:4px;";
		var loginDiv = "<div style='background-color:white;'>";
		loginDiv += "<div style='height:50px;text-align:center;line-height:50px;font-size:20px'>请登录</div>";
		loginDiv += "<div style='padding:15px;'>";
		loginDiv += "<input id='loginName' type='text' style='height:40px'  placeholder='帐号' />";
		loginDiv += "<input id='loginPass' type='password' style='height:40px'  placeholder='密码' />";
		loginDiv += "</div>";

		loginDiv += "<div style='padding-left:15px;padding-right:15px;padding-bottom:15px;margin-top:-10px'>";
		loginDiv += "<div class='grid'>";
		loginDiv += "<div class='col-1'><div onclick='javascript:FamilyUtils.Login(\"" + callback + "\")' style='" + btn1 + "'>登录</div></div>";
		loginDiv += "<div class='col-0' style='width:10px'></div>";
		loginDiv += "<div class='col-1'><div onclick='javascript:A.Popup.close();$native.openExMobiPage(\"res:page/register.uixml\")' class='background-color-red' style='" + btn2 + "'>注册</div></div>";
		loginDiv += "</div>";
		loginDiv += "</div>";

		loginDiv += '</div>';
		A.Popup.show({
			html : loginDiv,
			showCloseBtn : true,
			pos : "center"
		});

	};

	var _login = function(callback) {
		var loginName = $('input[type="text"]').val();
		var loginPass = $('input[type="password"]').val();
		if (!loginName) {
			Family.Toast.Show("请输入帐号");
			return;
		}
		if (!loginPass) {
			Family.Toast.Show("请输入密码");
			return;
		}

		Family.DoRequest({
			url : FamilyCache.Onlineurl(),
			data : "method=Online_Login&loginName=" + loginName + "&loginPass=" + loginPass + "&esn=" + DeviceUtil.getEsn(),
			isBlock : true,
			success : function(rs) {
				var data = Family.ToJSON(rs.responseText);
				if (data && data.response.code == 200) {
					if (data.body.loginInfo.state == 0) {
						Family.Toast.Show("帐号或密码错误,登录失败");
						return;
					}
					A.Popup.close();
					Family.Toast.Show("欢迎回来");
					callback && eval(callback + "()");
					FamilySetting.SetLoginInfo(rs.responseText);

				} else {
					Family.Toast.Show("登录失败");
				}
			},
			fail : function() {
				Family.Toast.Error("登录失败");
			}
		});
	};

	var _escapeEnter = function(value) {
		return value.replace(new RegExp("\r", "g"), "").replace(new RegExp("\n", "g"), "").replace(new RegExp("\t", "g"), "");
	};

	var _getJsonBody = function(responseText) {
		return responseText.replace("<?xml version=\"1.0\" encoding=\"utf-8\"?>", "").replace("<string xmlns=\"http://tempuri.org/\">", "").replace("</string>", "").replace(new RegExp("&lt;", "g"), "<").replace(new RegExp("&gt;", "g"), ">");
	};

	var _openWebView = function(url) {
		$native.openWebView(url, '<a data-transition="none"><a>');
	};

	var _getPushParam = function() {
		return DeviceUtil.getEsn() + "," + ClientUtil.getClientId() + "," + ClientUtil.getAppId();
	};

	return {
		EscapeFormData : _escapeFormData,
		LoadingFail : _loadingfail,
		LoadingH5 : _loadingH5,
		LoadingImg : _loadingImg,
		ShowRegisterTip : _registerTip, //弹出注册提示
		EscapeEnter : _escapeEnter,
		GetJsonBody : _getJsonBody,
		Login : _login,
		openWebView : _openWebView,
		GetPushParam : _getPushParam
	};
})();
