var _familyPaymentCallback = null;

var FamilyPayment = (function() {
	var _payTypes = {
		"yufukuan" : "66A3B4FA-7CE4-4DBB-9758-0E79ED8FF0AC", //物业宝
		"alipay" : "404759c6-be16-442a-8707-e072fd480aea", //支付宝
		"wx" : "553d7acc-102e-479d-93b4-5630c0627d28", //微信支付
		"tenpay" : "43698005-5379-4b4d-9d3c-4eb1985f1228"//财付通
	};

	//支付宝付款地址
	var _alipayurl = {
		b2b : function() {
			//手机购物付款地址
			return (FamilyCache.Debug ? "http://192.168.1.3/esUap3/" : "http://online.es-it.cn/") + "WebSolution/OnlinePayment/Alipay/order_b2b_create.aspx?";
		}
	};

	//支付宝付款
	var _alipay = function(params) {
		try {

			FamilyCache.SetCache("payment.cache.alipay.params", ClientUtil.jsonToString(params));

			var datas = "method=Online_GetAlipayParams";
			datas += "&orderId=" + params.orderId;
			datas += "&payTypeId=" + params.payTypeId;
			datas += "&payForward=" + params.direction;
			datas += "&amount=" + params.amount;
			datas += "&accountId=" + params.accountId;

			Family.DoRequest({
				url : FamilyCache.Onlineurl(),
				data : datas,
				isBlock : true,
				success : function(rs) {
					try {
						var data = Family.ToJSON(rs.responseText);
						if (data && data.response.code == 200) {
							var baseOnlineURL = (FamilyCache.Debug ? "http://192.168.1.3/esUap3/" : FamilyCache.Onlineurl().toLowerCase().replace("onlineservice.asmx/DataFromOnline".toLowerCase(), "")) + "WebSolution/OnlinePayment/Alipay/";
							var notifyURL = "";
							var type = params.type;

							if (type == 0) {
								//缴物业费
								notifyURL = FamilyDB.GetPostAddress().replace("onlineservice.asmx/DataFromProperty", "Websolution/OnlinePayment/Alipay/order_charge_notify.aspx");
							} else if (type == 1) {
								//购物
								notifyURL = baseOnlineURL + "order_b2b_notify.aspx";
							} else if (type == 2) {
								//充值
								notifyURL = baseOnlineURL + "order_chongzhi_notify.aspx";
							}

							//支付参数
							var alipay = data.body.alipay;
							var payJons = {
								"orderId" : params.orderId,
								"subject" : params.desc,
								"body" : (params.body || params.desc),
								"totalFee" : params.amount,
								"config" : {
									"partner" : alipay.partner,
									"seller" : alipay.sellerId,
									"rsaPriKey" : alipay.privatekey,
									"notifyURL" : notifyURL,
									"rsaPubKey" : alipay.publickey
								}
							};
							AlipayUtil.pay(payJons, FamilyPayment.AlipaySuccess, FamilyPayment.AlipayFail);
						} else {
							Family.Toast.Show("支付宝调用失败");
						}
					} catch(e) {
					}

				},
				fail : function() {
					Family.Toast.Show("支付宝调用失败");
				}
			});

		} catch(e) {
		}
	};

	//支付成功
	var _alipaySuccess = function(json) {
		//Family.Toast.Show("支付成功");
		var params = FamilyCache.GetCache("payment.cache.alipay.params");
		if (params) {
			params = ClientUtil.stringToJson(params);
			var dlg = Util.getWindowById(params.windowId);
			if (dlg) {
				var callback = params.callback;
				callback && dlg.callFunction(callback + "()");
			}
		}
	};
	//支付失败
	var _alipayFail = function(code, json) {
		if (code == 4000) {
			Family.Toast.Show("支付失败");
		} else if (code == 6002) {
			Family.Toast.Show("网络连接出错,请检查您的网络设置");
		} else if (code == 8000) {
			Family.Toast.Show("正在处理中");
		} else if (code == 6001) {
			//取消
		}

	};

	//财付通付款地址
	var _tenpayurl = {
		b2b : function() {
			return (FamilyCache.Debug ? "http://192.168.1.3/esUap3/" : "http://online.es-it.cn/") + "WebSolution/OnlinePayment/Tenpay/order_b2b_create.aspx?";
		}
	};

	/**
	 *付款
	 * @param {Object} options JSON格式
	 * {
	 * 	"type":"0缴物业费 1商城购物 2充值"
	 *  "orderId":"订单号",
	 *  "amount":"付款金额"
	 *  "desc":"付款描述",
	 *  "body":"订单详情", 第三方支付使用
	 *  "accountId":"物业公司帐号id",
	 *  "payTypeId":"付款方式",
	 *  "direction":"支付方向",
	 *  "balance":"物业宝余额",
	 *  "callback":"回调函数",
	 *  "params":"自定义参数" 格式a=1&b=2&c=3 ...
	 *  "wxNotifyurl":"微信异步通知地址"
	 *  "windowId":"当前窗口id"
	 * }
	 */
	var _orderPayment = function(options) {
		try {
			var params = "";
			for (var p in options) {
				if (p != "params") {
					params += p + "=" + encodeURI(options[p]) + "&amp;";
				}
			}
			params += options.params;

			FamilyCache.SetCache("family.payment.options", ClientUtil.jsonToString(options));
			if (options.amount <= 0 && options.type == 1) {
				//可能是优惠券
				params = params.replace(new RegExp("amp;", "g"), "");
				FamilyCache.SetCache("payment.wyb.windowId", options.windowId);
				FamilyCache.SetCache("payment.wyb.params", params);
				FamilyCache.SetCache("payment.wyb.callback", options.callback);
				FamilyCache.SetCache("payment.wyb.type", options.type);
				_balancePayGoods(params, options.callback, true);
			} else if (options.payTypeId.toUpperCase() == _payTypes.yufukuan.toUpperCase()) {
				var clientBase = FamilyDB.GetClientBase();
				if (parseFloat(options.balance) < parseFloat(options.amount)) {
					Family.Toast.Show("您的余额不足，请使用其他付款方式");
					return;
				}
				params = params.replace(new RegExp("amp;", "g"), "");
				FamilyCache.SetCache("payment.wyb.windowId", options.windowId);
				FamilyCache.SetCache("payment.wyb.params", params);
				FamilyCache.SetCache("payment.wyb.callback", options.callback);
				FamilyCache.SetCache("payment.wyb.type", options.type);
				if (clientBase.paymentPW && parseFloat(options.amount) > parseFloat(clientBase.lines)) {
					open("res:page/payment/order.password.check.uixml");
				} else {
					if (options.type == 0) {
						//物业宝缴物业费
						_balancePayCharge(params, options.callback);
					} else if (options.type == 1) {
						//物业宝购物
						_balancePayGoods(params, options.callback, false);
					}
				}

			} else if (options.payTypeId.toUpperCase() == _payTypes.alipay.toUpperCase()) {
				//var url = _alipayurl.b2b() + params;
				//FamilyCache.SetCache("cache.order.cashier.url", url);
				//open("res:page/payment/order.cashier.uixml");
				//支付宝支付
				var versons = ClientUtil.getVersion().split(".");
				var ver = "";
				var os = DeviceUtil.getOs();
				for (var i = 0; i < versons.length; i++) {
					if (i != versons.length - 1) {
						ver += versons[i] + "";
					}
				}
				if (ver > 580) {
					//5.8.0以上的版本使用支付宝SDK支付
					_alipay(options);
				} else {
					var url = _alipayurl.b2b() + params;
					FamilyCache.SetCache("cache.order.cashier.url", url);
					open("res:page/payment/order.cashier.uixml");
				}
			} else if (options.payTypeId.toUpperCase() == _payTypes.tenpay.toUpperCase()) {
				//财付通
				var url = _tenpayurl.b2b() + params;
				FamilyCache.SetCache("cache.order.cashier.url", url);
				open("res:page/payment/order.cashier.uixml");
			} else if (options.payTypeId.toUpperCase() == _payTypes.wx.toUpperCase()) {
				//微信支付
				try {
					if (options.type == 1) {
						options.wxNotifyurl = FamilyCache.Onlineurl().replace("onlineservice.asmx/DataFromOnline", "Websolution/OnlinePayment/WXApp/order_b2b_notify.aspx");
					}
					if (!WeixinUtil.isWeixinInstalled()) {
						Family.Toast.Show("您的手机未安装微信");
						return;
					}
					if (!WeixinUtil.isSupportPay()) {
						Family.Toast.Show("您的微信暂不支持支付功能，请升级您的微信");
						return;
					}
					_familyPaymentCallback = options.callback;
					var datas = "?orderId=" + options.orderId;
					datas += "&desc=" + options.desc;
					datas += "&amount=" + options.amount;
					datas += "&accountId=" + options.accountId;
					datas += "&payTypeId=" + options.payTypeId;
					datas += "&direction=" + options.direction;
					datas += "&type=" + options.type;
					datas += "&wxNotifyurl=" + options.wxNotifyurl;
					FamilyCache.SetCache("payment.wx.callback", options.callback);
					Family.DoRequest({
						url : FamilyCache.Onlineurl().replace("onlineservice.asmx/DataFromOnline", "Websolution/OnlinePayment/WXApp/order.aspx") + encodeURI(datas),
						data : "",
						isBlock : true,
						success : function(rs) {
							var result = rs.responseText;
							if (result) {
								result = Family.ToJSON(result);
								var jsonData = {};
								jsonData.appId = result.appId;
								jsonData.appSecret = result.appSecret;
								jsonData.partnerId = result.partnerId;
								jsonData.orderId = result.orderId;
								jsonData.nonceStr = result.nonceStr;
								jsonData.timestamp = result.timestamp;
								jsonData.package = "Sign=WXPay";
								jsonData.sign = result.sign;
								WeixinUtil.payOrder(jsonData, _wxPayOrdercallBackFun);
							} else {
								Family.Toast.Show("支付错误，暂时无法使用微信支付");
							}
						},
						fail : function() {

						}
					});
				} catch(e) {
					Family.Toast.Show("支付错误，暂时无法使用微信支付");
				}
			}
		} catch(e) {

		}
	};

	/**
	 *物业宝余额缴物业费
	 * @param {Object} params 提交参数
	 * @param {Object} callback 回调函数
	 */
	var _balancePayCharge = function(params, callback) {
		try {
			_familyPaymentCallback = callback;
			Family.DoRequest({
				url : FamilyDB.GetPostAddress(),
				data : "method=Property_BalancePayCharge&" + params,
				onComplete : function() {
					Family.ProcessBar.Show("正在付款");
				},
				success : function(rs) {
					Family.ProcessBar.Hide();
					try {
						var data = Family.ToJSON(rs.responseText);
						if (data && data.response.code == 200) {
							var state = data.body.state;
							if (state == "OK") {
								Family.Toast.Show("缴费成功");
								var _callback = FamilyCache.GetCache("payment.wyb.callback");
								if (_callback) {
									_callback && window.callFunction(_callback + "()");
								} else {
									_familyPaymentCallback && window.callFunction(_familyPaymentCallback + "()");
								}
								FamilyCache.SetCache("payment.wyb.callback", "");
							}
						} else {
							Family.Toast.Error("缴费失败");
						}
					} catch(e) {
						Family.ProcessBar.Hide();
					}

				},
				fail : function() {
					Family.ProcessBar.Hide();
					Family.Toast.Error("缴费失败");
				}
			});
		} catch(e) {

		}
	};

	/**
	 *物业宝购物
	 * @param {Object} params
	 * @param {Object} callback
	 */
	var _balancePayGoods = function(params, callback, isShowBlock) {
		try {
			_familyPaymentCallback = callback;
			Family.DoRequest({
				url : FamilyCache.Onlineurl(),
				data : "method=Online_BalancePayGoods&" + params,
				isBlock : isShowBlock,
				onComplete : function() {
					Family.ProcessBar.Show("正在付款");
				},
				success : function(rs) {
					Family.ProcessBar.Hide();
					try {
						var data = Family.ToJSON(rs.responseText);
						if (data && data.response.code == 200) {
							var state = data.body.state;
							if (state == "OK") {
								Family.Toast.Show("支付成功");
								var _callback = FamilyCache.GetCache("payment.wyb.callback");
								if (_callback) {
									_callback && window.callFunction(_callback + "()");
								} else {
									_familyPaymentCallback && window.callFunction(_familyPaymentCallback + "()");
								}
								FamilyCache.SetCache("payment.wyb.callback", "");
							}
						} else {
							Family.Toast.Error("支付失败");
						}
					} catch(e) {
						Family.ProcessBar.Hide();
					}
				},
				fail : function(rs) {
					Family.ProcessBar.Hide();
					Family.Toast.Error("支付失败");
				}
			});
		} catch(e) {

		}
	};

	return {
		OrderPayment : _orderPayment, //支付接口 所有支付都调用此接口
		BalancePayCharge : _balancePayCharge, //物业宝缴物业费
		BalancePayGoods : _balancePayGoods, //物业宝购物
		PayTypes : _payTypes, //付款方式

		AlipaySuccess : _alipaySuccess, //支付宝付款成功
		AlipayFail : _alipayFail//支付宝付款失败
	};

})();

function _wxPayOrdercallBackFun(result) {
	if (result.errCode == 0) {
		Family.Toast.Show("支付成功");
		var _callback = FamilyCache.GetCache("payment.wx.callback");
		if (_callback) {
			_callback && window.callFunction(_callback + "()");
		} else {
			_familyPaymentCallback && window.callFunction(_familyPaymentCallback + "()");
		}
		FamilyCache.SetCache("payment.wx.callback", "");
	} else if (result.errCode == -1) {
		Family.Toast.Show(result.errMsg);
	}
}
