var objectId = "",
    clientId = "",
    esareaId = "",
    title = "",
    areaId = "";
function onLoad() {
	try {
		var params = ClientUtil.stringToJson(FamilyCache.GetCache("family.house.params"));
		objectId = params.objectId;
		clientId = params.clientId;
		esareaId = params.esareaId;
		areaId = params.areaId;
		title = params.title;
		var listTitle = document.getElementById("listTitle");
		if (listTitle) {
			listTitle.innerHTML = title;
		}
		getParameter();
		getCity();
	} catch(e) {
	}
}

//付款方式参数绑定
function getParameter() {
	try {
		var datas = "method=Property_HouseRental_Parameter&type=fkfs&guid=35641835-D305-437B-AAA4-FC4368C04026";
		Family.DoRequest({
			url : FamilyDB.GetPostAddress(),
			data : datas,
			isBlock : true,
			success : function(rs) {
				try {
					var data = Family.ToJSON(rs.responseText);
					if (data && data.response.code == 200) {
						var json = data.body.datas;
						var select = document.getElementById("payment");
						select.removeAll();
						for (var i = 0; i < json.length; i++) {
							var dt = json[i];
							var option = document.createElement("option");
							option.text = dt.name;
							option.value = dt.guid;
							select.add(option);
						}
						select.selectedIndex = 0;
					}
				} catch(e) {
				}
			},
			fail : function() {
			}
		});
	} catch(e) {
	}
}

//城市
function getCity() {
	try {
		var datas = "method=Property_HouseRental_Parameter&type=city&guid=00000000-0000-0000-0000-000000000000";
		Family.DoRequest({
			url : FamilyDB.GetPostAddress(),
			data : datas,
			isBlock : true,
			success : function(rs) {
				try {
					var data = Family.ToJSON(rs.responseText);
					if (data && data.response.code == 200) {
						var json = data.body.datas;
						var select = document.getElementById("city");
						select.removeAll();
						for (var i = 0; i < json.length; i++) {
							var dt = json[i];
							var option = document.createElement("option");
							option.text = dt.name;
							option.value = dt.guid;
							select.add(option);
						}
						select.selectedIndex = 0;
						getRegion();
					}
				} catch(e) {
				}
			},
			fail : function() {
			}
		});
	} catch(e) {
	}
}

//区域
function getRegion() {
	var city = document.getElementById("city").value;
	if (city == "00000000-0000-0000-0000-000000000000") {
		return;
	}
	try {
		var datas = "method=Property_HouseRental_Parameter&type=region&guid=" + city;
		Family.DoRequest({
			url : FamilyDB.GetPostAddress(),
			data : datas,
			isBlock : true,
			success : function(rs) {
				try {
					var data = Family.ToJSON(rs.responseText);
					if (data && data.response.code == 200) {
						var json = data.body.datas;
						var select = document.getElementById("region");
						select.removeAll();
						for (var i = 0; i < json.length; i++) {
							var dt = json[i];
							var option = document.createElement("option");
							option.text = dt.name;
							option.value = dt.guid;
							select.add(option);
						}
						select.selectedIndex = 0;
					}
				} catch(e) {
				}
			},
			fail : function() {
			}
		});
	} catch(e) {
	}
}

function getRentalType() {
	try {
		var t = document.getElementById("fldType");
		if (t.value == "售") {
			document.getElementById("houseS").style.display = "block";
			document.getElementById("houseZ").style.display = "none";
		} else if (t.value == "租") {
			document.getElementById("houseS").style.display = "none";
			document.getElementById("houseZ").style.display = "block";
		} else {
			document.getElementById("houseS").style.display = "block";
			document.getElementById("houseZ").style.display = "block";
		}
	} catch(e) {
	}
}

var addState = 0;
//发布房屋
function getInsertHouse() {
	try {
		if (addState == 1) {
			Family.Toast.Show("房屋租售信息已发布，请等待管理员审核");
			return;
		}
		var fldType = document.getElementById("fldType").value;
		var priceZ = document.getElementById("priceZ").value;
		var price = document.getElementById("price").value;
		var payment = document.getElementById("payment").value;
		var city = document.getElementById("city").value;
		var region = document.getElementById("region").value;
		var room = document.getElementById("room").value;
		var hall = document.getElementById("hall").value;
		var toilet = document.getElementById("toilet").value;
		var balcony = document.getElementById("balcony").value;

		priceZ = parseFloat((priceZ || 0)).toFixed(2);
		price = parseFloat((price || 0)).toFixed(2);
		var datas = "method=Property_HouseRental_HouseOperate&operate=add&clientId=" + clientId;
		datas += "&objectId=" + objectId + "&esareaId=" + esareaId + "&payment=" + payment;
		datas += "&type=" + (fldType || '租售') + "&price=" + price + "&priceZ=" + priceZ;
		datas += "&city=" + city + "&region=" + region + "&room=" + room + "&hall=" + hall;
		datas += "&toilet=" + toilet + "&balcony=" + balcony;
		Family.DoRequest({
			url : FamilyDB.GetPostAddress(),
			data : datas,
			isBlock : true,
			success : function(rs) {
				try {
					var data = Family.ToJSON(rs.responseText);
					if (data && data.response.code == 200) {
						addState = 1;
						Family.Toast.Show("发布房屋租售信息成功，请等待管理员审核");
					} else {
						Family.Toast.Show("发布房屋租售信息失败");
					}
				} catch(e) {
					Family.Toast.Show("发布房屋租售信息失败");
				}
			},
			fail : function() {
				Family.Toast.Show("发布房屋租售信息失败");
			}
		});
	} catch(e) {
	}
}

//取消发布房屋
function getCancelHouse() {
	try {
		var datas = "method=Property_HouseRental_HouseOperate&houseId=" + houseId + "&operate=del";
		Family.DoRequest({
			url : FamilyDB.GetPostAddress(),
			data : datas,
			isBlock : true,
			success : function(rs) {
				try {
					var data = Family.ToJSON(rs.responseText);
					if (data && data.response.code == 200) {
						Family.Toast.Show("房屋租售信息取消成功，请等待管理员审核");
					} else {
						Family.Toast.Show("房屋租售信息取消失败");
					}
				} catch(e) {
					Family.Toast.Show("房屋租售信息取消失败");
				}
			},
			fail : function() {
				Family.Toast.Show("房屋租售信息取消失败");
			}
		});
	} catch(e) {
	}
}