var areaId = easysoft.getQueryString("areaId");
var clientId = easysoft.getQueryString("clientId") || easysoft.EmptyId;
var propertyKey = easysoft.getQueryString("propertyKey");
var pattern = parseInt(easysoft.getQueryString("pattern") || 0);
$(function() {
	if (pattern == 0) {
		$("#noregister").show();
		$("#userpannel").hide();
		return;
	}
	$("#noregister").hide();
	$("#userpannel").show();
	
	setTimeout(function(){
		loadHead();
		loadClientInfo();
		loadClientMsgCount();
	},1000);//延迟加载，防止ios在无网络状态下click事件失效
	

});

/***
 *退出帐号
 */
function exitsAccount() {
	try {
		nativePage.executeScript("changeAccount()");
	} catch(e) {

	}
}

/**
 *获取头像
 */
function loadHead() {
	var url = FamilyCache.Onlineimgurl() + clientId + ".jpg?r=" + easysoft.NewId();
	$(".container1-mask-brief-user-logo").removeAttr("data-original").attr("data-original", url).lazyload({
		effect : "fadeIn"
	});
}

/**
 *获取用户信息
 */
function loadClientInfo() {
	$.ajax({
		url : FamilyCache.OnlineBaseurl() + "OnlinePlatform/webapp/data.aspx",
		type : "POST",
		dataType : "jsonp",
		jsonp : "jsoncallback",
		data : {
			method : "OnlineGetClientCenterInfo",
			clientId : clientId,
			areaId : areaId
		},
		success : function(data) {
			if (data && data.response.code == 200) {
				var clientInfo = data.body;
				$(".container1-mask-brief-user-nickname").text(clientInfo.nickname);
				$("#balance").text(clientInfo.balance);
				$("#integral").text(clientInfo.integral);
				$("#notUsedTicket").text(clientInfo.notUsedTicket);
				if (clientInfo.waitpayorder > 0) {
					$('<span class="container3-wapper-cell-banner">' + clientInfo.waitpayorder + '</span>').appendTo("#waitpay");
				} else {
					$("#waitpay").find(".container3-wapper-cell-banner").remove();
				}

				if (clientInfo.waitsendorder > 0) {
					$('<span class="container3-wapper-cell-banner">' + clientInfo.waitsendorder + '</span>').appendTo("#waitsend");
				} else {
					$("#waitsend").find(".container3-wapper-cell-banner").remove();
				}

				if (clientInfo.waitreciveorder > 0) {
					$('<span class="container3-wapper-cell-banner">' + clientInfo.waitreciveorder + '</span>').appendTo("#waitrecive");
				} else {
					$("#waitrecive").find(".container3-wapper-cell-banner").remove();
				}

				if (clientInfo.waitcommentorder > 0) {
					$('<span class="container3-wapper-cell-banner">' + clientInfo.waitcommentorder + '</span>').appendTo("#waitcomment");
				} else {
					$("#waitcomment").find(".container3-wapper-cell-banner").remove();
				}
			}
		}
	});
}

/**
 *获取未阅读的消息数量
 */
function loadClientMsgCount() {
	$.ajax({
		url : FamilyCache.OnlineBaseurl() + "OnlinePlatform/webapp/data.aspx",
		type : "POST",
		dataType : "jsonp",
		jsonp : "jsoncallback",
		data : {
			method : "OnlineGetClientMsg",
			clientId : clientId,
			areaId : areaId,
			propertyKey : propertyKey
		},
		success : function(data) {
			if (data && data.response.code == 200) {
				var msgList = data.body.msgList;
				$("#mymsg").attr("src", "../../image/html/" + (msgList.length > 0 ? "user-msg-red.png" : "user-msg.png"));
			}
		}
	});
}

function showPage(page) {
	if (pattern == 0) {
		return;
	}
	if ( typeof (ExMobiWindow) != "undefined") {
		ExMobiWindow.open(page);
	}
}

document.addEventListener("onstart", function() {
	loadClientInfo();
	loadClientMsgCount();
}, false);

/**
 *打开上传头像面板
 */
function openUploadDialog() {
	$(".camara").show();
}

var pwidth = 720;
/**
 *关闭上传头像面板
 */
function closeCamaraDialog() {
	$(".camara").hide();
}

function uploadFromCamara() {
	$(".camara").hide();
	Family.Camera({
		pwidth : pwidth,
		iscrop : true,
		callback : function(path) {
			uploadImg(path);
		}
	});
}

function uploadFromFile() {
	$(".camara").hide();
	Family.SelectCameraPhoto({
		pwidth : pwidth,
		iscrop : true,
		callback : function(path) {
			uploadImg(path);
		}
	});
}

function uploadImg(path) {
	if ( typeof (nativePage) != "undefined") {
		nativePage.executeScript("uploadImg('" + path + "')");
	}
}
