function onStart() {
	try {
		if (FamilyCache.IsShowWelcome && !FamilyCache.GetCache(FamilyCache.WelcomeCacheName)) {
			open("res:page/welcome.uixml");
			return;
		}
		var familyBase = FamilyDB.GetFamilyBase();
		var clientBase = FamilyDB.GetClientBase();
		if (!clientBase) {
			open("res:page/login.uixml?autoLogin=false");
			return;
		}
		$("main_select_area").href = "res:page/register/register.area.uixml?pattern=" + (familyBase.pattern == 0 ? "visit" : "normal");
		var areaname = familyBase.areaName;
		$("currentAreaName").html(areaname || "");
		$("logo").html('<img src="' + FamilyCache.Onlineurl() + "?method=Online_GetCompanyLogo&amp;areaId=" + familyBase.areaId + '"  defaultsrc="res:image/head/logo.png" class="main-header-logo" />');
		showRegisterTicket();
		Family.ProcessBar.Show();
		var url = FamilyCache.OnlineBaseurl() + "OnlinePlatform/webapp/main.aspx";
		url += "?areaId=" + ( familyBase ? familyBase.areaId : FamilyCache.EmptyId);
		url += "&clientId=" + (( familyBase ? familyBase.pattern : 0) == 1 ? ( clientBase ? clientBase.id : FamilyCache.EmptyId) : FamilyCache.EmptyId);
		url += "&propertyKey=" + ( familyBase ? familyBase.propertyKey : "");
		url += "&patten=" + ( familyBase ? familyBase.pattern : 0);
		url += "&esareaId=" + ( familyBase ? familyBase.esareaId : FamilyCache.EmptyId);
		Family.CreateWebView({
			container : "body",
			id : "webview",
			url : url,
			className : "webview",
			showprogress : true,
			onreceivedtitle : "onBrowserTitleChange"
		});
	} catch(e) {
		open("res:page/login.uixml?autoLogin=false");
		Family.ProcessBar.Hide();
	}
}

function onBrowserTitleChange() {
	Family.ProcessBar.Hide();
}

function maininit() {
	try {
		onStart();
		var bl = DeviceUtil.isSupportBluetooth();
		if (bl) {
			var os = DeviceUtil.getOs();
			if (os == "ios") {
				$("div_ios").show();
				$("div_android").hide();
			} else {
				$("div_ios").hide();
				$("div_android").show();
			}
		}
		//删除设备缓存
		FamilyDB.DelBluetooth();
		var doorList = FamilyDB.GetDoors();
		if (doorList && doorList.length > 0) {
			BluetoothInit();
		}
	} catch(e) {

	}

}

//------------------------------蓝牙门禁开门开始------------------------------//
var bluetime;
/**
 * 蓝牙门禁-初始化
 */
function BluetoothInit() {
	try {
		var native;
		var os = DeviceUtil.getOs();
		if (os == "ios") {
			native = document.getElementById("door_ios");
		} else {
			native = document.getElementById("door_android");
		}
		if (native) {
			native.call("init", "", "");
			bluetime = setTimeout("bluetoothCache()", 3000);
		}
	} catch(e) {
	}
}

/**
 * 设置蓝牙门禁的设备缓存
 */
function bluetoothCache() {
	try {
		clearTimeout(bluetime);
		FamilyDB.DelBluetooth();
		var native;
		var os = DeviceUtil.getOs();
		if (os == "ios") {
			native = document.getElementById("door_ios");
		} else {
			native = document.getElementById("door_android");
		}
		if (native) {
			var rs = native.call("getDiscoveredDevices");
			var data = Family.ToJSON(rs);
			var json = data.bleDevInfos;
			if (json && json.length > 0) {
				for (var i = 0; i < json.length; i++) {
					json[i].id = Family.NewId();
					json[i].name = (json[i].name || "");
					json[i].mac = ((json[i].mac).toUpperCase() || "");
					json[i].rssi = (json[i].rssi || "");
					json[i].address = (json[i].address || "");
				}
				FamilyDB.SetBluetooth(json);
			}
		}
	} catch(e) {
	}
}

/**
 * 蓝牙门禁-开门
 */
function BluetoothOpen(blue_mac, blue_pwd, code) {
	try {
		if (!blue_mac) {
			Family.Toast.Show("MAC地址不能为空,请联系管理员配置");
			return;
		}
		var native;
		var os = DeviceUtil.getOs();
		if (os == "ios") {
			native = document.getElementById("door_ios");
		} else {
			native = document.getElementById("door_android");
		}
		var rs = native.call("openDoor", blue_mac.toLowerCase(), "50", blue_pwd.toLowerCase());
		if (rs) {
			if (rs.indexOf("成功") > -1 || rs == "0") {
				WriteLod(2, code);
				Family.Toast.Show("开门成功");
			} else if (rs == "5") {
				Family.Toast.Show("您的蓝牙未开启,请打开蓝牙后重新打开页面");
			} else {
				Family.Toast.Show("开门失败,请重试!错误码:" + ClientUtil.jsonToString(rs));
			}
		} else {
			Family.Toast.Show("开门失败,请重试");
		}
	} catch(e) {
	}
}

/**
 * 智能开门日志   @type 日志添加类别：2-蓝牙，1-wifi
 */
function WriteLod(type, code) {
	try {
		var ESN = DeviceUtil.getEsn();
		var clientId = (FamilyDB.GetClientBase() ? FamilyDB.GetClientBase().id : FamilyCache.EmptyId);
		//var url = FamilyDB.GetPostAddress().replace("onlineservice.asmx/DataFromProperty", "WapService.asmx/DataProperty");
		var url = FamilyDB.GetPostAddress();
		var datas = "method=Property_DoorOpenLog&eid=" + clientId + "&code=" + code + "&primarykey=" + ESN + "&type=" + type;
		Family.DoRequest({
			url : url,
			data : datas,
			isBlock : false,
			success : function(rs) {
			},
			fail : function(rs) {
			}
		});
	} catch(e) {
	}
}

//------------------------------蓝牙门禁开门结束------------------------------//
/**
 *显示注册送优惠券
 */
function showRegisterTicket() {
	try {
		var hasRegisterTicket = window.getParameter("hasRegisterTicket");
		if (hasRegisterTicket) {
			var ticketlist = FamilyCache.GetCache("cache.register.ticketlist");
			if (ticketlist) {
				ticketlist = ClientUtil.stringToJson(ticketlist);
				if (ticketlist.length > 0) {
					//$("fix_ticketList").clear().provide(ticketlist).show();
					//$("fix_register_ticket").show();
					open("res:page/takeTicket.uixml");
				}
			}
		}
	} catch(e) {

	}
}
